#!/bin/bash

cd "$(dirname "$(realpath $0)")"

CONFIG_FILE="${1}"
if [[ "$CONFIG_FILE" == "" ]]; then
	CONFIG_FILE="config.ini"
fi


#php src/Animarr.php "$CONFIG_FILE" &
#DAEMON_PID=$!


MAGNET_FOLDER=$(awk -F "=" '/magnet.service.folder/ {print $2}' "$CONFIG_FILE")
TORRENT_FOLDER=$(awk -F "=" '/torrent.cache.folder/ {print $2}' "$CONFIG_FILE")

nodejs src/MagnetService.js "${MAGNET_FOLDER}" "${TORRENT_FOLDER}" &
MAGNET_PID=$!

SERVER_HOST=$(awk -F "=" '/server.host/ {print $2}' "$CONFIG_FILE")
SERVER_PORT=$(awk -F "=" '/server.port/ {print $2}' "$CONFIG_FILE")

function finish {
	#kill $DAEMON_PID
	kill $MAGNET_PID
}
trap finish EXIT

rm "config_${SERVER_PORT}.ini"

ln -s "$CONFIG_FILE" "config_${SERVER_PORT}.ini"

php src/Animarr.php "$CONFIG_FILE"

#php -S "$SERVER_HOST:$SERVER_PORT" -t web/


