<?php

include "common.php";

use Animarr\Release\Release;

$aid = 0;

if(!isset($_GET["release_id"])){
    header("Location: index.php");
    die();
}
$release_id = preg_replace("[^a-fA-f0-9]", "", $_GET["release_id"]);
$extractor = new \Animarr\Extractor\SceneExtractor($aniDB);

$selector = new \Animarr\Selector();

if(isset($_GET["episode"])){
    $episode = intval($_GET["episode"]);

    printHeader("Release $release_id, episode $episode");

    echo "<h1>Release $release_id, episode $episode</h1>";

    $release = $database->getReleaseEpisode($release_id, $episode);
    if($release === null){
        var_dump($release_id, $episode);
        //header("Location: index.php");
        die();
    }
    $debug = [];
    $extractor->extractInformation($release->getOriginalTitle(), false, $debug);
    echo "<pre>";
    var_dump($debug);
    var_dump($release->serialize());
	echo "\n";
	echo "Priority: " . $selector->calculatePriority($release) . "\n";
	echo "Pedantic priority: " . $selector->calculatePedanticPriority($release) . "\n";
	echo "Match:\n";
	var_dump($aniDB->matchRelease($release));
    echo "</pre>";
}else{
    printHeader("Release $release_id");

    echo "<h1>Release $release_id</h1>";

    $release = $database->getRelease($release_id);
    if($release === null){
        var_dump($release_id);
        //header("Location: index.php");
        die();
    }
    $debug = [];
    //var_dump($release);
    if($release instanceof \Animarr\Release\MultiRelease){
	    $extractor->extractInformation($release->getOriginalTitle(), false, $debug);
	    echo "<pre>";
	    var_dump($debug);
	    var_dump($release->serialize());
	    echo "\n------------------------------------------\n";
	    echo "</pre>";
        foreach ($release->getContents($extractor) as $r){
            $extractor->extractInformation($r->getOriginalTitle(), false, $debug);
            echo "<pre>";
            var_dump($debug);
            var_dump($r->serialize());
			echo "\n";
			echo "Priority: " . $selector->calculatePriority($r) . "\n";
			echo "Pedantic priority: " . $selector->calculatePedanticPriority($r) . "\n";
			echo "Match:\n";
			var_dump($aniDB->matchRelease($r));
            echo "</pre>";
        }
    }else{
        $extractor->extractInformation($release->getOriginalTitle(), false, $debug);
        echo "<pre>";
        var_dump($debug);
        var_dump($release->serialize());	
		echo "\n";
		echo "Priority: " . $selector->calculatePriority($release) . "\n";
		echo "Pedantic priority: " . $selector->calculatePedanticPriority($release) . "\n";
		echo "Match:\n";
		var_dump($aniDB->matchRelease($release));
        echo "</pre>";
    }


}



printFooter();
